/*
	File:		AppleEvents.c

	Contains:	Handlers for the 4 "required" events

	Written by: Chris White	

	Copyright:	Copyright  1996-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				8/6/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
				

*/


// System Includes

#ifndef __APPLEEVENTS__
	#include <AppleEvents.h>
#endif




// Application includes

#ifndef __BAREBONES__
	#include "BareBones.h"
#endif

#ifndef __PROTOTYPES__
	#include "Prototypes.h"
#endif





// Static Prototypes
static pascal OSErr HandleOapp ( AEDescList* aevt, AEDescList* reply, long refCon );
static pascal OSErr HandleQuit ( AEDescList* aevt, AEDescList* reply, long refCon );
static pascal OSErr HandleOdoc ( AEDescList* aevt, AEDescList* reply, long refCon );
static pascal OSErr HandlePdoc ( AEDescList* aevt, AEDescList* reply, long refCon );



#pragma segment Initialize

OSErr InstallAppleEventHandlers ( void )
{
	OSErr	theErr;
	
	
	theErr = AEInstallEventHandler ( kCoreEventClass, kAEOpenApplication, NewAEEventHandlerProc ( HandleOapp ), 0, false );
	if ( theErr )	goto CleanupAndBail;

	theErr = AEInstallEventHandler ( kCoreEventClass, kAEOpenDocuments, NewAEEventHandlerProc ( HandleOdoc ), 0, false );
	if ( theErr )	goto CleanupAndBail;

	theErr = AEInstallEventHandler ( kCoreEventClass, kAEPrintDocuments, NewAEEventHandlerProc ( HandlePdoc ), 0, false );
	if ( theErr )	goto CleanupAndBail;

	theErr = AEInstallEventHandler ( kCoreEventClass, kAEQuitApplication, NewAEEventHandlerProc ( HandleQuit ), 0, false );
	if ( theErr )	goto CleanupAndBail;
	
	
CleanupAndBail:

	return theErr;
	
}	// InstallAppleEventHandlers



#pragma segment Core

static pascal OSErr HandleOapp ( AEDescList* aevt, AEDescList* reply, long refCon )
{
	#pragma unused(aevt,reply,refCon)
	return errAEEventNotHandled;
}



static pascal OSErr HandleOdoc ( AEDescList* aevt, AEDescList* reply, long refCon )
{
	#pragma unused(aevt,reply,refCon)
	return errAEEventNotHandled;
}



static pascal OSErr HandlePdoc ( AEDescList* aevt, AEDescList* reply, long refCon )
{
	#pragma unused(aevt,reply,refCon)
	return errAEEventNotHandled;
}



static pascal OSErr HandleQuit ( AEDescList* aevt, AEDescList* reply, long refCon )
{
	#pragma unused(aevt,reply,refCon)
	gQuit = true;
	
	return noErr;
}




